import React from "react";
import { WithStyles } from "@material-ui/core";
import { WithEditorFieldProps } from "../EditorField";
export declare const styles: {
    root: {
        padding: string;
        "&:hover": {
            backgroundColor: string;
        };
    };
    label: {
        margin: number;
        "align-items": string;
        padding: number;
    };
    icon: {
        borderRadius: number;
        width: number;
        height: number;
        boxShadow: string;
        backgroundColor: string;
        backgroundImage: string;
        "$root.Mui-focusVisible &": {
            outline: string;
            outlineOffset: number;
        };
        "input:hover ~ &": {
            backgroundColor: string;
        };
        "input:disabled ~ &": {
            boxShadow: string;
            background: string;
        };
    };
    checkedIcon: {
        backgroundColor: string;
        backgroundImage: string;
        "&:before": {
            display: string;
            width: number;
            height: number;
            backgroundImage: string;
            content: string;
        };
        "input:hover ~ &": {
            backgroundColor: string;
        };
    };
    formWrap: {
        "flex-direction": string;
        "align-items": string;
    };
    helpText: {
        margin: string;
    };
};
export interface EditorCheckboxFieldProps extends WithEditorFieldProps<WithStyles<typeof styles>> {
}
declare const _default: React.ComponentType<Pick<React.PropsWithChildren<EditorCheckboxFieldProps>, "pointer" | "disabled" | "children" | "onChange" | "value" | "required" | "schema" | "readonly" | "registry" | "errorReport" | "parentType"> & import("@material-ui/core").StyledComponentProps<"root" | "icon" | "label" | "checkedIcon" | "formWrap" | "helpText">>;
export default _default;
