var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useState } from "react";
import { FormControl, FormHelperText, Popover, TextField as MuiTextField, withStyles } from "@material-ui/core";
import { getErrorMessages, getErrorsForPointer } from "../EditorErrorMessages";
import { ChromePicker } from "react-color";
import PopupState, { bindTrigger, bindPopover } from "material-ui-popup-state";
export var DEFAULT_CONVERTER = "rgba_hex";
export var converters = {
    rgba: function (c) { return "rgba(" + c.rgb.r + ", " + c.rgb.g + ", " + c.rgb.b + ", " + c.rgb.a + ")"; },
    hex: function (c) { return c.hex; },
    rgba_hex: function (c) { return c.rgb.a === 1 ? converters.hex(c) : converters.rgba(c); }
};
export var styles = {
    root: {
        width: "100%"
    },
    input: {
        color: "rgba(0, 0, 0, 0.87)"
    }
};
var EditorColorField = function (props) {
    var schema = props.schema, value = props.value, readonly = props.readonly, required = props.required, disabled = props.disabled, onChange = props.onChange, classes = props.classes, pointer = props.pointer, errorReport = props.errorReport, registry = props.registry;
    var _a = useState(schema.default || value || ""), localValue = _a[0], setValue = _a[1];
    var handleChange = React.useCallback(function (newValue) {
        if (newValue === "") {
            newValue = undefined;
        }
        if (onChange) {
            setValue(newValue);
            onChange(newValue);
        }
    }, [onChange]);
    var errors = getErrorsForPointer(pointer, errorReport);
    var errorMessages = getErrorMessages(schema, errors, registry);
    return (React.createElement(PopupState, { variant: "popover", popupId: "color-popup-popover" }, function (popupState) { return (React.createElement(FormControl, { id: "color-popup", className: classes.root },
        React.createElement(MuiTextField, __assign({ autoComplete: "off", label: schema.title || "", disabled: disabled, required: required, onChange: handleChange, defaultValue: schema.default || localValue, inputProps: {
                readOnly: readonly,
                "aria-label": schema.description || ""
            }, error: errorMessages.length > 0, value: localValue }, bindTrigger(popupState))),
        React.createElement(Popover, __assign({}, bindPopover(popupState), { anchorOrigin: {
                vertical: "bottom",
                horizontal: "left"
            }, PaperProps: {
                className: "mui-paper-color"
            }, marginThreshold: 0 }),
            React.createElement(ChromePicker, { color: localValue, onChange: function (c) {
                    var newValue = converters[DEFAULT_CONVERTER](c);
                    handleChange(newValue);
                } })),
        React.createElement(FormHelperText, { error: errorMessages.length > 0 }, errorMessages.length ? errorMessages[0] : schema.description))); }));
};
export default withStyles(styles, { name: "DcEditorColorField" })(EditorColorField);
